<?php 

class Banner extends Controller
{
	public $total=NULL;
	public $groupInfo=NULL;
	public $row=array();
	public $paginationResult=NULL;
	public $totalGroups=0;
	public function listing()
	{
		$this->deleteBanners();
		$this->total();
		$this->totalGroups();
		if(isset($_GET["g"]) and $this->totalGroups==1)
		{
			$this->editGroup();
			$this->groupInfo();
			$this->load($this->view("view/common/header"));
			$this->load($this->view("view/common/left_column"));
			$this->load($this->view("view/banner/home"));
			$this->load($this->view("view/common/footer"));
		}else
		{
			header("location:".URL."/banner/groups");
		}
	}
	public function deleteBanners()
	{
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			foreach($_POST["selected"] as $id)
			{
				$query->delete_query("banner","where id=?",array($id));
			}
			header("location:".URL."/banner/listing&g=".$_GET["g"]);
		}
	}
	public function deleteGroups()
	{
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			foreach($_POST["selected"] as $g)
			{
				$query->delete_query("banner","where b_group=?",array($g));
				$query->delete_query("banner_group","where id=?",array($g));
			}
			header("location:".URL."/banner/groups");
		}
	}
	public function total()
	{
		if(isset($_GET["g"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("banner","where b_group=?",array(abs($_GET["g"])));
			$this->total=$tot;
		}
	}
	public function add()
	{
		$this->addNewBanner();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/banner/add"));
		$this->load($this->view("view/common/footer"));
	}
	public function totalGroups()
	{
		if(isset($_GET["g"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("banner_group","where id=?",array(abs($_GET["g"])));
		}else
		{
			$query=new Model();
			$tot=$query->select_total_records("banner_group",NULL,NULL);
		}
		$this->totalGroups=$tot;
	}
	public function groups()
	{
		$this->deleteGroups();
		$this->addNewGroup();
		$this->totalGroups();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/banner/groups"));
		$this->load($this->view("view/common/footer"));
	}
	public function edit()
	{
		$this->editBanner();
		$this->bannerInfo();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/banner/edit"));
		$this->load($this->view("view/common/footer"));
	}
	public function addNewGroup()
	{
		if(isset($_POST["banner_group"]))
		{
			$banner_group=strip_tags($_POST["banner_group"]);
			if(strlen($banner_group)>0)
			{
				$time=time();
				$query=new Model();
				$insert=$query->insert_query("banner_group","title=?, time=?",array($banner_group,$time));
				if($insert)
				{
					$query->select_single_query("banner_group","where time=?",array($time));
					$id=$query->results["id"];
					header("location:".URL."/banner/listing&g=".$id);
				}else
				{
					header("location:".URL."/banner/groups");
				}
			}
		}
	}
	public function editGroup()
	{
		if(isset($_POST["banner_group"]))
		{
			$banner_group=strip_tags($_POST["banner_group"]);
			if(strlen($banner_group)>0)
			{
				$query=new Model();
				$update=$query->update_query("banner_group","title=? where id=?",array($banner_group,$_GET["g"]));
				if($update)
				{
					header("location:".URL."/banner/listing&g=".$_GET["g"]);
				}
			}
		}
	}
	public function listGroups()
	{
		$query=new Model();
		$query->fetch_query("banner_group",NULL,NULL);
		$results=$query->results;
		foreach($results as $row)
		{
			echo "<tr>
					  <td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					  <td><a href='".URL."/banner/listing&g=".$row["id"]."'>".$row["title"]."</a></td>
					  <td><a href='".URL."/banner/listing&g=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
	}
	public function editBanner()
	{
		if(isset($_POST["title"]))
		{
			$title=trim(strip_tags($_POST["title"]));
			$content=$_POST["content"];
			$b_group=$_POST["b_group"];
			$link=trim($_POST["link"]);
			$link_text=trim($_POST["link_text"]);
			$image=abs($_POST["image"]);
			$sort_order=$_POST["sort_order"];
			$query=new Model();
			$set="b_group=?, title=?, content=?, link=?, link_text=?, image=?, sort_order=? where id=?";
			$ar=array($b_group,$title,$content,$link,$link_text,$image,$sort_order,abs($_GET["id"]));
			$up=$query->update_query("banner",$set,$ar);
			if($up){header("location:".URL."/banner/edit&id=".$_GET["id"]);}
		}
	}
	public function bannerInfo()
	{
		if(isset($_GET["id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("banner","where id=?",array(abs($_GET["id"])));
			if($tot==1)
			{
				$query->select_single_query("banner","where id=?",array(abs($_GET["id"])));
				$this->row=$query->results;
			}else
			{
				header("location:".URL."/banner/listing");
			}
		}else
		{
			header("location:".URL."/banner/listing");
		}
	}
	public function addNewBanner()
	{
		if(isset($_POST["title"]))
		{
			$title=trim(strip_tags($_POST["title"]));
			$content=$_POST["content"];
			$b_group=$_POST["b_group"];
			$link=trim($_POST["link"]);
			$link_text=trim($_POST["link_text"]);
			$image=abs($_POST["image"]);
			$sort_order=$_POST["sort_order"];
			$query=new Model();
			$set="b_group=?, title=?, content=?, link=?, link_text=?, image=?, sort_order=?";
			$ar=array($b_group,$title,$content,$link,$link_text,$image,$sort_order);
			$add=$query->insert_query("banner",$set,$ar);
			if($add){header("location:".URL."/banner/listing&g=".$b_group);}
		}
	}
	public function image($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("media","where id=?",array($id));
		if($tot==1)
		{
			$query->select_single_query("media","where id=?",array($id));
			$row=$query->results;
			$query->results=NULL;
			$imgurl=$row["url"];
			$file=ROOT."uploads/".$imgurl;
			if(strlen($imgurl)>1 and file_exists($file))
			{
				$url=URL."/uploads/".$imgurl;
			}else
			{
				$url=URL."/plugins/media/image.png";
			}
		}else
		{
			$url=URL."/plugins/media/image.png";
		}
		return $url;
	}
	public function listBanners()
	{
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else{$by="id";}
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else{$order="desc";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$by="order by ".$by." ".$order;
		$start=($pageNum*$this->listPerPage)-($this->listPerPage);
		$limit=" limit ".$start.",".$this->listPerPage;
		$this->paginationResult="Toplam afiş = <b>".$this->total."</b>; Toplam sayfa = <b>".$totalPages."</b> ";
		$query=new Model();
		$query->fetch_query("banner","where b_group=?".$by.$limit,array(abs($_GET["g"])));
		$results=$query->results;
		foreach($results as $row)
		{
			$image="<img src='".$this->image($row["image"])."' title='".$row["title"]."'>";
			echo "<tr>
				  <td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
				  <td>#".$row["id"]."</td>
				  <td>".$image."</td>
				  <td>".htmlspecialchars($row["title"])."</td>
				  <td><a href='".URL."/banner/edit&id=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
	}
	public function titleBy()
	{
		return array("image","title","id");
	}
	public function order()
	{
		return array("asc","desc");
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/banner/listing&g=".$_GET["g"]."&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/banner/listing&g=".$_GET["g"]."&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function pagination()
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order="&order=".$_GET["order"];}else {$order="&order=asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by="&by=".$_GET["by"];}else {$by="&by=id";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$link=URL."/banner/listing&g=".$_GET["g"].$by.$order;
		$getAllPages=$this->getPagination($totalPages,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function groupInfo()
	{
		if(isset($_GET["g"]))
		{
			$query=new Model();
			$query->select_single_query("banner_group","where id=?",array(abs($_GET["g"])));
			$this->groupInfo=$query->results;
		}
	}
	public function groupOptions($id)
	{
		$query=new Model();
		$query->fetch_query("banner_group",NULL,NULL);
		$results=$query->results;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$id){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' $sc>".$row["title"]."</option>";
		}
		return  $options;
	}
}
?>