<?php 

class Category extends Controller
{	
	public $allCategories=array();
	public $parents_as_text=NULL;
	public $extra=NULL;
	public $row=array();
	public $belowCats=array();
	
	public function contMethods()
	{
		$this->deleteCategories();
	}
	public function listing()
	{
		$this->load($this->view("view/category/category"));
	}
	public function add()
	{
		echo $this->addNewCategory();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/category/add"));
		$this->load($this->view("view/common/footer"));
	}
	public function edit()
	{
		if(isset($_GET["id"]))
		{
			$catId=abs($_GET["id"]);
			$getCat=new Model();
			$result=$getCat->select_total_records("category","where id=?",array($catId));
			if($result==0)
			{
				$this->load($this->view("view/category/add"));	
			}else
			{
				echo $this->editCategory();
				$query=new Model();
				$query->select_single_query("category","where id=?",array($catId));
				$this->row=$query->results;
				$this->load($this->view("view/category/edit"));
			}
			
		}else 
		{
			$this->load($this->view("view/category/add"));	
		}
	}
	public function search()
	{
		$this->load($this->view("view/category/search"));
	}
	public function categorySearch()
	{
		if(isset($_GET["search"]))
		{
			$search=$_GET["search"];
		}else 
		{
			$search="";
		}
		$query=new Model();
		$query->fetch_query("category","where title like ? limit 0,10 ",array("%".$search."%"));
		$this->row=$query->results;
	}
	public function getTotalCategories()
	{
		$getTotal=new Model();
		$total=$getTotal->select_total_records("category",NULL,NULL);
		return $total;
	}
	public function getParent($id)
	{
		$getParent=new Model();
		$getParent->select_single_query("category","where id=?",array($id));
		$getCategory=$getParent->results;
		if(count($getCategory)==0)
		{
			return "<span class='mainCategoryText'>Ana Kategori</span>";
		}else 
		{
			return $getCategory["title"];
		}
	}
	public function getCategories()
	{
		$totalPages=ceil($this->getTotalCategories()/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$start=($pageNum*($this->listPerPage))-($this->listPerPage);
		$per=$this->listPerPage;
		$paginationResult="Toplam kategori = <b>".$this->getTotalCategories()."</b>; Toplam sayfa = <b>".$totalPages."</b>";
		$this->extra=$paginationResult;
		if(isset($_GET["by"])){$by=$_GET["by"];}else{$by="id";}
		$protected_by=array("title","id","parent_id");
		$protected_order=array("asc","desc");
		if(!in_array($by,$protected_by)){$by="id";}
		if(isset($_GET["order"])){$order=$_GET["order"];}else{$order="asc";}
		if(!in_array($order,$protected_order)){$order="asc";}
		$orderBy="order by ".$by." ".$order;
		$limit=$orderBy." limit ".$start.",".$this->listPerPage;
		$getAll=new Model();
		$getAll->fetch_query("category",$limit,NULL);
		$this->allCategories=$getAll->results;
		foreach ($this->allCategories as $row)
		{
			$parentName=$this->getParent($row["parent_id"]);
			echo "<tr>";
			echo "	<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					<td>".$row["title"]."</td>
					<td>".$parentName."</td>
					<td class='td_actions'><a href='".URL."/category/edit&id=".$row["id"]."'>Düzenle</a></td>
					<td class='td_actions'><a href='".URL."/category/add&parent=".$row["id"]."'>Buraya Ekle</a></td>
			     ";
			echo "</tr>";
		}
	}
	public function toFirstParent($id)
	{
		$getUniq=new Model();
		$getUniq->select_single_query("category","where id=?", array($id));
		$getted=$getUniq->results;
		if($getted["parent_id"]!=0 || $getted["parent_id"]!=NULL)
		{
			$this->toFirstParent($getted["parent_id"]);
			$this->parents_as_text.=$getted["title"]." &#8250; ";
		}else 
		{
			$this->parents_as_text.=$getted["title"];
		}
	}
	public function getParentsOption($id)
	{
		$prc=new Model();
		$prc->select_query("category",NULL,NULL);
		$fetch=$prc->results;
		$options=array();
		foreach ($fetch as $row)
		{
			if($row["id"]!=$id)
			{
				$sc=NULL;
			}else 
			{
				$sc="selected='selected'";
			}
			if($row["parent_id"]==0 || $row["parent_id"]==NULL)
			{
				array_push($options,"<option value='".$row["id"]."' $sc>".$row["title"]."</option>");
			}else 
			{
				$this->toFirstParent($row["parent_id"]);
				$gettext=$this->parents_as_text;
				$this->parents_as_text=NULL;
				array_push($options,"<option value='".$row["id"]."' $sc>".$gettext." ".$row["title"]."</option>");
			}			
		}
		return $options;
	}
	public function getBelows($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("category","where parent_id=?",array($id));
		if($tot==0)
		{
			if(!in_array($id,$this->belowCats))
			{
				array_push($this->belowCats,$id);
			}
		}else
		{
			$query->fetch_query("category","where parent_id=?",array($id));
			$results=$query->results;
			if(!in_array($id,$this->belowCats))
			{
				array_push($this->belowCats,$id);
			}
			foreach($results as $row)
			{
				$this->getBelows($row["id"]);
			}
		}
	}
	public function setParentOptions($id,$self)
	{
		$query=new Model();
		$query->fetch_query("category",NULL,NULL);
		$results=$query->results;
		$options=NULL;
		$ana=array("id"=>0,"title"=>"Ana Kategori");
		foreach ($results as $row)
		{
			$this->getBelows($self);
		}
		array_unshift($results,$ana);
		foreach ($results as $value)
		{
			if(!in_array($value["id"],$this->belowCats) or $value["id"]==0)
			{
				if($value["id"]==$id){$sc="selected='selected'";}else{$sc=NULL;}
				$options.="<option value='".$value["id"]."' $sc>".$value["title"]."</option>";
			}
		}
		$query=NULL;
		return $options;
	}
	public function setSeflink($title)
	{
		if(isset($_GET["id"]))
		{
			$catId=abs($_GET["id"]);
		}else 
		{
			$catId=0;
		}
		$query=new Model();
		$result=$query->select_total_records("category","where (title=? or seflink=?) and id!=?",array($title,$title,$catId));
		if($result==0)
		{
			$newSeflink=$this->clear($title);
		}else 
		{
			$newSeflink=$this->clear($title)."-".($result+1);
		}
		return $newSeflink;
	}
	public function addNewCategory()
	{
		if(isset($_POST["title"]))
		{
			$title=$_POST["title"];
			$seflink=$_POST["seflink"];
			if($seflink==NULL || $seflink=="")
			{
				$seflink=$this->setSeflink($title);
			}else 
			{
				$seflink=$this->setSeflink($seflink);
			}
			$list_on=$_POST["list_on"];
			$meta_title=$_POST["meta_title"];
			$meta_desc=$_POST["meta_desc"];
			$meta_tags=$_POST["meta_tags"];
			$parent_id=$_POST["parent_id"];
			$sort_order=$_POST["sort_order"];
			if($title!=NULL || $title!="")
			{
				$set="title=?, parent_id=?, seflink=?, sort_order=?, meta_title=?, meta_desc=?, meta_tags=?, list_on=?";
				$array=array($title,$parent_id,$seflink,$sort_order,$meta_title,$meta_desc,$meta_tags,$list_on);
				$model=new Model();
				$query=$model->insert_query("category",$set,$array);
				if($query)
				{
					$model->select_single_query("category","where seflink=?",array($seflink));
					$id=$model->results["id"];
					header("location:".URL."/category/edit&id=".$id);
				}else 
				{
					$result=$this->formResults("Kritik bir hata oluştu!!!");
				}
			}else 
			{
				$result=$this->formResults("Lütfen kategori ismini giriniz!!!");
			}
		}
	}
	public function categoryListOption($val)
	{
		$values=array("Hayır","Evet");
		$options=NULL;
		foreach($values as $value => $text)
		{
			if($value==$val){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value."' $sc>".$text."</option>";
		}
		return $options;
	}
	public function editCategory()
	{
		if(isset($_POST["title"]))
		{	
			$catId=abs($_GET["id"]);
			$title=$_POST["title"];
			$seflink=$_POST["seflink"];
			$list_on=$_POST["list_on"];
			if($seflink==NULL || $seflink=="")
			{
				$seflink=$this->setSeflink($title);
			}else 
			{
				$seflink=$this->setSeflink($seflink);
			}
			$meta_title=$_POST["meta_title"];
			$meta_desc=$_POST["meta_desc"];
			$meta_tags=$_POST["meta_tags"];
			$parent_id=$_POST["parent_id"];
			$sort_order=$_POST["sort_order"];
			if($title!=NULL || $title!="")
			{
				$set="title=?, parent_id=?, seflink=?, sort_order=?, meta_title=?, meta_desc=?, meta_tags=?, list_on=? where id=?";
				$array=array($title,$parent_id,$seflink,$sort_order,$meta_title,$meta_desc,$meta_tags,$list_on,$catId);
				$model=new Model();
				$query=$model->update_query("category",$set,$array);
				if($query)
				{
					$result=$this->formResults("Güncelleme işlemi başarılı");
					return $result;
				}else 
				{
					$result=$this->formResults("Kritik bir hata oluştu!!!");
					return $result;
				}
				
			}else 
			{
				$result=$this->formResults("Lütfen kategori ismini giriniz!!!");
				return $result;
			}
		}
	}
	public function pagination()
	{
		$total=$this->getTotalCategories();
		if(isset($_GET["by"])){$by="&by=".$_GET["by"];}else{$by=NULL;}
		if(isset($_GET["order"])){$order="&order=".$_GET["order"];}else{$order=NULL;}
		$link=URL."/category/listing".$by.$order;
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function deleteCategories()
	{
		if(isset($_POST["selected"]))
		{
			$this->extra=NULL;
			foreach($_POST["selected"] as $id)
			{
				$getItem=new Model();
				$getItem->select_single_item("category","where id=?",array($id));
				$title=$getItem->results["title"];
				$getItem->results=NULL;
				$delete=new Model();
				$deleteResult=$delete->delete_query("category","where id=?",array($id));
				if($deleteResult)
				{
					$this->extra.="<div><b>".$title." </b> silindi.</div>";	
				}else 
				{
					$this->extra.="<div><em>".$title." </em> silinirken bir hata oluştu !!!!</div>";
				}
			}
			$result=$this->formResults($this->extra);
			echo $result;
		}
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"])){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"])){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->getTotalCategories()/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/category/listing&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/category/listing&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
}

?>