<?php 
class Content extends Controller 
{
	public $text=NULL;
	public $row=NULL;
	public $author=NULL;
	public $totalRecords=NULL;
	public $paginationResult=NULL;
	public function __construct()
	{
		$this->getAuthor();
		$this->totalRecords();
		$this->setNewPerPage();
		$this->listPerPage();
	}
	public function getAuthor()
	{
		global $session;
		$this->author=$session->userInfo["id"];
	}
	public function admin()
	{
		global $session;
		if($session->userInfo["rank"]=="admin"){return true;}else{return false;}
	}
	public function adminEditor()
	{
		global $session;
		if($session->userInfo["rank"]=="admin" or $session->userInfo["rank"]=="editor"){return true;}else{return false;}
	}
	public  function listing()
	{
		$this->load($this->view("view/common/header")); 
		$this->load($this->view("view/common/left_column"));
		$this->deleteSelectedContents();
		$this->load($this->view("view/content/index"));
		$this->load($this->view("view/common/footer")); 
	}
	public  function add()
	{
		if(isset($_GET["type"]) and array_key_exists($_GET["type"],$this->contentTypes()))
		{
			$this->load($this->view("view/content/add_".$_GET["type"]));
		}else
		{
			$this->load($this->view("view/content/add_post"));
		}
	}
	public  function edit()
	{
		if(isset($_GET["id"]))
		{
			$get=new Model();
			$tot=$get->select_total_records("posts","where post_id=?",array($_GET["id"]));
			if($tot==0)
			{
				header("location:".URL."/content/listing");
			}else 
			{
				$get->select_single_query("posts","where post_id=?",array($_GET["id"]));
				$this->row=$get->results;
			}
			if(isset($_GET["type"]) and array_key_exists($_GET["type"],$this->contentTypes()))
			{
				$this->load($this->view("view/content/edit_".$_GET["type"]));
			}else
			{
				$this->load($this->view("view/content/edit_post"));
			}
		}else
		{
			header("location:".URL."/content/listing");
		}
	}
	public function contentTypeOption($type)
	{
		$types=$this->contentTypes();
		foreach ($types as $value => $text)
		{
			if($value==$type){$sc="selected='selected'";}else{$sc=NULL;}
			echo "<option value='".$value."' ".$sc.">".$text."</option>";
		}
	}
	public function contentTypes()
	{
		$types=array("video" =>"Video listesi","audio" => "Ses listesi","photo"=>"Galeri","post"=>"Yazı içerik", "html"=>"HTML içerik", "other"=>"Diğer içerik");
		return $types;
	}
	public function getNewButton()
	{
		$ar=$this->contentTypes();
		if(isset($_GET["type"]) and array_key_exists($_GET["type"],$ar))
		{
			$link=URL."/content/add&type=".$_GET["type"];
			$i=$_GET["type"];
		}else 
		{
			$i="post";
			$link=URL."/content/add&type=post";
		}
		return "<a href='".$link."'>".$ar[$i]." oluştur</a>";
	}

	public function setParentOptions($id)
	{
		$complex=NULL;
		foreach($this->getParentsOption($id) as $singleOption)
		{
			$complex.=$singleOption;
		}
		$this->text=NULL;
		return $complex;
	}
	public function getParentsOption($id)
	{
		$prc=new Model();
		$prc->select_query("category",NULL,NULL);
		$fetch=$prc->results;
		$options=array();
		foreach ($fetch as $row)
		{
			if($row["id"]!=$id)
			{
				$sc=NULL;
			}else 
			{
				$sc="selected='selected'";
			}
			if($row["parent_id"]==0 || $row["parent_id"]==NULL)
			{
				array_push($options,"<option value='".$row["id"]."' $sc>".$row["title"]."</option>");
			}else 
			{
				$this->toFirstParent($row["parent_id"]);
				$gettext=$this->text;
				$this->text=NULL;
				array_push($options,"<option value='".$row["id"]."' $sc>".$gettext." ".$row["title"]."</option>");
			}			
		}
		return $options;
	}
	public function toFirstParent($id)
	{
		$getUniq=new Model();
		$getUniq->select_single_query("category","where id=?", array($id));
		$getted=$getUniq->results;
		if($getted["parent_id"]!=0 || $getted["parent_id"]!=NULL)
		{
			$this->toFirstParent($getted["parent_id"]);
			$this->text.=$getted["title"]." &#8250; ";
		}else 
		{
			$this->text.=$getted["title"];
		}
	}
	public function getStatus($st)
	{
		$status=array("Pasif","Aktif");
		$options=NULL;
		foreach ($status as $sta)
		{
			if(array_search($sta,$status)==$st)
			{
				$sc="selected='selected'";
			}else 
			{
				$sc=NULL;
			}
			$options.="<option value='".array_search($sta,$status)."' $sc>".$sta."</option>";
		}
		return $options;
	}
	public function setSeflink($title,$post_title)
	{
		$title=$this->clear(trim($title));
		if(isset($_GET["id"]))
		{
			$id=$_GET["id"];
		}else 
		{
			$id=0;
		}
		$query=new Model();
		$result=$query->select_total_records("posts","where post_id != ? and post_seflink = ?",array($id,$title));
		if($result==0)
		{
			$newSeflink=$this->clear($title);
		}else 
		{
			$query=NULL;
			$query=new Model();
			$result=$query->select_total_records("posts","where post_title = ? and post_id != ?",array($post_title,$id));
			$newSeflink=$this->clear($title)."-".($result+1);
		}
		return $newSeflink;
	}
	public function addNewPost()
	{
		if(isset($_POST["post_title"]))
		{
			$post_id=$this->addContent("post");
			header("location:".URL."/content/edit&type=post&id=".$post_id);
		}
	}
	public function editNewPost()
	{
		if(isset($_POST["post_title"]))
		{
			if($this->adminEditor() or $this->author==$this->row["post_author"])
			{
				$post_id=$this->editContent("post");
				header("location:".URL."/content/edit&type=post&id=".$post_id);
			}
		}
	}
	public function addContent($type)
	{
		$post_category=$_POST["post_category"];
		$post_title=$_POST["post_title"];
		$post_seflink=$_POST["post_seflink"];
		if($post_seflink==NULL || $post_seflink=="")
		{
			$post_seflink=$this->setSeflink($post_title,$post_title);
		}else 
		{
			$post_seflink=$this->setSeflink($post_seflink,$post_title);
		}
		if(isset($_POST["content_list_type"]))
		{
			$content_list_type=$_POST["content_list_type"];
		}else
		{
			$content_list_type="standart";
		}
		$post_author=$_SESSION["user"];
		$post_content=$_POST["post_content"];
		$post_image=$_POST["post_image"];
		$date_creation=date("d M Y").";".date("H:i:s").";".time();
		$date_modified=$date_creation;
		$meta_title=$_POST["meta_title"];
		$meta_desc=$_POST["meta_desc"];
		$meta_tags=$_POST["meta_tags"];
		$post_author=$_SESSION["user"];
		$post_status=$_POST["post_status"];
		$comment_status=$_POST["comment_status"];
		$microtime=microtime();
		// start insert new post
		$set="post_category=?, 
			  post_title=?, 
			  post_content=?, 
			  post_seflink=?, 
			  post_image=?, 
			  date_creation=?, 
			  date_modified=?,
			  meta_title=?, 
			  meta_desc=?, 
			  meta_tags=?, 
			  post_author=?, 
			  post_status=?, 
			  comment_status=?, 
			  content_type=?,
			  content_list_type=?, 
			  post_microtime=?";
		$ar=array($post_category,
					 $post_title,
					 $post_content,
					 $post_seflink,
					 $post_image,
					 $date_creation,
					 $date_modified,
					 $meta_title,
					 $meta_desc,
					 $meta_tags,
					 $post_author,
					 $post_status,
					 $comment_status,
					 $type,
					 $content_list_type,
					 $microtime
					 );
		$query=new Model();
		$add=$query->insert_query("posts",$set,$ar);
		if($add)
		{
			$query=NULL;
			$query=new Model();
			$query->select_single_query("posts","where post_microtime=?",array($microtime));
			$row=$query->results;
			return $row["post_id"];
		}
	}
	public function editMediaContent($edit)
	{
		if(isset($_POST["post_title"]))
		{
			if($this->adminEditor() or $this->author==$this->row["post_author"])
			{
				if(array_key_exists($_POST["content_type"],$this->contentTypes()))
				{
					$contentType=$_POST["content_type"];
				}else
				{
					$contentType="post";
				}
				if($edit=="edit")
				{
					$postId=$this->editContent($contentType);
				}else
				{
					$postId=$this->addContent($contentType);
				}
				
				$query=new Model();
				$del=$query->delete_query("gallery","where content_id=?",array($postId));
				if(isset($_POST["imageId"]))
				{	
					$totalMedias=count($_POST["imageId"]);
					for($i=0; $i<$totalMedias; $i++)
					{
						$a=$totalMedias-1-$i;
						$mediaId=$_POST["imageId"][$a];
						$title=$_POST["imageTitle"][$a];
						$content=$_POST["imageContent"][$a];
						$sort_order=$_POST["imageOrder"][$a];
						$ar=array($mediaId,$postId,$title,$content,$sort_order);
						$add=$query->insert_query("gallery","media_id=?, content_id=?, foto_title=?, foto_content=?, sort_order=?",$ar);
					}
				}
				if(isset($postId)){header("location:".URL."/content/edit&type=".$contentType."&id=".$postId);}
			}
		}
	}
	public function getImageGalleries()
	{
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($_GET["id"]));
		$all=$query->results;
		$galleries=NULL;
		if(count($all)!=0)
		{
			foreach($all as $row)
			{
				$title=$row["foto_title"];
				$content=$row["foto_content"];
				$mediaId=$row["media_id"];
				$sort_order=$row["sort_order"]/1;
				$single=$query->select_single_query("media","where id=?",array($mediaId));
				$row=$query->results;
				$url=URL."/uploads/".$row["url"];
				$galleries.="<div class='galleryImage'>
							 <div class='imageObject' style='background-image:url(".$url.")'></div>
							 <b>".mb_substr($title,0,40)."...</b>
							 <p>".mb_substr($content,0,40)."...</p>
							 <input type='hidden' name='imageId[]' value='".$mediaId."'>
							 <input type='hidden' name='imageTitle[]' class='editTitle' value='".$title."'>
							 <input type='hidden' name='imageContent[]' class='editContent' value='".$content."'>
							 <input type='hidden' name='imageOrder[]' class='editOrder' value='".$sort_order."'>
							 </div>";
				
			}
			return $galleries;
		}
	}
	public function getVideoGalleries()
	{
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($_GET["id"]));
		$all=$query->results;
		$galleries=NULL;
		if(count($all)!=0)
		{
			foreach($all as $row)
			{
				$title=$row["foto_title"];
				$content=$row["foto_content"];
				$mediaId=$row["media_id"];
				$sort_order=$row["sort_order"]/1;
				$single=$query->select_single_query("media","where id=?",array($mediaId));
				$row=$query->results;
				$url=URL."/uploads/".$row["url"];
				$galleries.="<div class='galleryImage'>
							 <video class='imageObject' controls type='".$row["mime_type"]."' src='".$url."'></video>
							 <b>".mb_substr($title,0,40)."...</b>
							 <p>".mb_substr($content,0,40)."...</p>
							 <input type='hidden' name='imageId[]' value='".$mediaId."'>
							 <input type='hidden' name='imageTitle[]' class='editTitle' value='".$title."'>
							 <input type='hidden' name='imageContent[]' class='editContent' value='".$content."'>
							 <input type='hidden' name='imageOrder[]' class='editOrder' value='".$sort_order."'>
							 </div>";
				
			}
			return $galleries;
		}
	}
	public function getAudioGalleries()
	{
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($_GET["id"]));
		$all=$query->results;
		$galleries=NULL;
		if(count($all)!=0)
		{
			foreach($all as $row)
			{
				$title=$row["foto_title"];
				$content=$row["foto_content"];
				$mediaId=$row["media_id"];
				$sort_order=$row["sort_order"]/1;
				$single=$query->select_single_query("media","where id=?",array($mediaId));
				$row=$query->results;
				$url=URL."/uploads/".$row["url"];
				$galleries.="<div class='galleryImage'>
							 <audio class='imageObject' controls type='".$row["mime_type"]."' src='".$url."'></audio>
							 <b>".mb_substr($title,0,40)."...</b>
							 <p>".mb_substr($content,0,40)."...</p>
							 <input type='hidden' name='imageId[]' value='".$mediaId."'>
							 <input type='hidden' name='imageTitle[]' class='editTitle' value='".$title."'>
							 <input type='hidden' name='imageContent[]' class='editContent' value='".$content."'>
							 <input type='hidden' name='imageOrder[]' class='editOrder' value='".$sort_order."'>
							 </div>";
				
			}
			return $galleries;
		}
	}
	public function getOtherGalleries()
	{
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($_GET["id"]));
		$all=$query->results;
		$galleries=NULL;
		if(count($all)!=0)
		{
			foreach($all as $row)
			{
				$title=$row["foto_title"];
				$content=$row["foto_content"];
				$mediaId=$row["media_id"];
				$sort_order=$row["sort_order"]/1;
				$single=$query->select_single_query("media","where id=?",array($mediaId));
				$row=$query->results;
				$url=URL."/uploads/".$row["url"];
				$galleries.="<div class='galleryImage'>
							 <div class='imageObject' style='background-image:url(".URL."/plugins/media/file.png)'></div>
							 <b>".mb_substr($title,0,40)."...</b>
							 <p>".mb_substr($content,0,40)."...</p>
							 <input type='hidden' name='imageId[]' value='".$mediaId."'>
							 <input type='hidden' name='imageTitle[]' class='editTitle' value='".$title."'>
							 <input type='hidden' name='imageContent[]' class='editContent' value='".$content."'>
							 <input type='hidden' name='imageOrder[]' class='editOrder' value='".$sort_order."'>
							 </div>";
				
			}
			return $galleries;
		}
	}
	public function getHtmlGalleries()
	{
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($_GET["id"]));
		$all=$query->results;
		$galleries=NULL;
		if(count($all)!=0)
		{
			foreach($all as $row)
			{
				$title=$row["foto_title"];
				$content=$row["foto_content"];
				$sort_order=$row["sort_order"]/1;
				$galleries.="<div class='galleryImage'  data-result='html'>
							 <b>".mb_substr($title,0,40)."...</b>
							 <div class='imageObject' data-result='html'>".htmlspecialchars($content)."</div>
							 <input type='hidden' name='imageId[]'>
							 <input type='hidden' name='imageTitle[]' class='editTitle' value='".$title."'>
							 <input type='hidden' name='imageContent[]' class='editContent' value='".htmlspecialchars($content)."'>
							 <input type='hidden' name='imageOrder[]' class='editOrder' value='".$sort_order."'>
							 </div>";
				
			}
			return $galleries;
		}
	}
	public function editContent($type)
	{
		$post_category=$_POST["post_category"];
		$post_title=$_POST["post_title"];
		$post_seflink=$_POST["post_seflink"];
		if($post_seflink==NULL || $post_seflink=="")
		{
			$post_seflink=$this->setSeflink($post_title,$post_title);
		}else 
		{
			$post_seflink=$this->setSeflink($post_seflink,$post_title);
		}
		if(isset($_POST["content_list_type"]))
		{
			$content_list_type=$_POST["content_list_type"];
		}else
		{
			$content_list_type="standart";
		}
		$post_content=$_POST["post_content"];
		$post_image=$_POST["post_image"];
		$date_creation=date("d M Y").";".date("H:i:s").";".time();
		$date_modified=$date_creation;
		$meta_title=$_POST["meta_title"];
		$meta_desc=$_POST["meta_desc"];
		$meta_tags=$_POST["meta_tags"];
		$post_status=$_POST["post_status"];
		$comment_status=$_POST["comment_status"];
		$microtime=microtime();
		// start insert new post
		$set="post_category=?, 
			  post_title=?, 
			  post_content=?, 
			  post_seflink=?, 
			  post_image=?, 
			  date_creation=?, 
			  date_modified=?,
			  meta_title=?, 
			  meta_desc=?, 
			  meta_tags=?,  
			  post_status=?, 
			  comment_status=?, 
			  content_type=?,
			  content_list_type=?, 
			  post_microtime=? where post_id=?";
		$ar=array($post_category,
					 $post_title,
					 $post_content,
					 $post_seflink,
					 $post_image,
					 $date_creation,
					 $date_modified,
					 $meta_title,
					 $meta_desc,
					 $meta_tags,
					 $post_status,
					 $comment_status,
					 $type,
					 $content_list_type,
					 $microtime,
					 $_GET["id"]
					 );
		$query=new Model();
		$update=$query->update_query("posts",$set,$ar);
		return $_GET["id"];
	}
	public function getSingleImage($id)
	{
		$query=new Model();
		$query->select_single_query("media","where id=? and type=?",array($id,"image"));
		$row=$query->results;
		if($query->results)
		{
			$file=ROOT."uploads/".$row["url"];
			if(file_exists($file))
			{
				$url=URL."/uploads/".$row["url"];
			}else 
			{
				$url=URL."/plugins/media/image.png";
			}
			return "<img src='".$url."' title='".$row["title"]."' alt='".$row["title"]."'>";
		}else 
		{
			return "<img src='".URL."/plugins/media/image.png"."' title='resim yok'>";
		}
	}
	public function listGallery()
	{
		$content_id=$this->row["post_id"];
		$query=new Model();
		$query->select_query("gallery","where content_id=? order by sort_order asc, id asc",array($content_id));
		$fetch=$query->results;
		$list=NULL;
		$query=NULL;
		if($fetch)
		{
			foreach($fetch as $row)
			{
				$img=$this->getSingleImage($row["media_id"]);
				$list.="<tr>
							<td>".$img."</td>
							<td>".$row["foto_title"]."</td>
							<td>".$row["foto_content"]."</td>
							<td>".$row["sort_order"]."</td>
						</tr>";
			}
			return $list;
		}else
		{
			return false;
		}
	}
	public function contentListType($type)
	{
		$ar=array(
					"gallery" =>"Galeri listeleme",
					"blog"=>"Blog listeleme"
		);
		$types=array("gallery","blog");
		foreach ($types as $option)
		{
			if($option==$type)
			{
				$sc="selected='selected'";
			}else
			{
				$sc=NULL;
			}
			echo "<option value='".$option."' $sc>".$ar[$option]."</option>";
		}
	}
	public function setTableTitle($sql_title,$text)
	{
		if(isset($_GET["type"]))
		{
			if(array_key_exists($_GET["type"],$this->contentTypes()))
			{
				$type="&type=".$_GET["type"];
			}else 
			{
				$type=NULL;
			}
		}else
		{ 
			$type=NULL; 
		}
		if(isset($_GET["user"])){$user="&user";}else{$user=NULL;}
		if(isset($_GET["order"])){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"])){$by=$_GET["by"];}else {$by="post_id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->totalRecords/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/content/listing".$user.$type."&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/content/listing".$user.$type."&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function totalRecords()
	{
		$query=new Model();
		if(isset($_GET["type"]))
		{
			if(array_key_exists($_GET["type"],$this->contentTypes()))
			{
				if(isset($_GET["user"]))
				{
					$tot=$query->select_total_records("posts","where content_type=? and post_author=?", array($_GET["type"],$this->author));
				}else
				{
					$tot=$query->select_total_records("posts","where content_type=?", array($_GET["type"]));
				}
			}else 
			{
				if(isset($_GET["user"]))
				{
					$tot=$query->select_total_records("posts","where post_author=?", array($this->author));
				}else
				{
					$tot=$query->select_total_records("posts",NULL, NULL);
				}
			}
		}else 
		{
			if(isset($_GET["user"]))
			{
				$tot=$query->select_total_records("posts","where post_author=?", array($this->author));
			}else
			{
				$tot=$query->select_total_records("posts",NULL, NULL);
			}
		}
		$this->totalRecords=$tot;
	}
	public function orderKeys()
	{
		$ar=array("post_id","content_type","sort_order","post_title","post_category");
		return $ar;
	}
	public function deleteSelectedContents()
	{
		if(isset($_POST["selected"]))
		{
				$message=NULL;
				foreach($_POST["selected"] as $conId)
				{
					$query=new Model();
					$query->select_single_query("posts","where post_id=?",array($conId));
					$row=$query->results;
					if($this->adminEditor() or $this->author==$row["post_author"])
					{	
						$message.="<b>".$row["post_title"]."</b> silindi.";
						$query->delete_query("gallery","where content_id=?",array($conId));
						$query->delete_query("posts","where post_id=?",array($conId));
						$query=NULL;
					}else
					{
						$message.="<b style='color:red;'>".$query->results["post_title"]." silmeye yetkiniz yok.</b><br>";
					}
				}
				echo $this->formResults($message);
		}
	}
	public function listAllPosts()
	{
		$totalPages=ceil($this->totalRecords/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$start=($this->listPerPage * $pageNum) -($this->listPerPage);
		$limit = " limit ".$start.",".$this->listPerPage;
		
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->orderKeys()))
		{
			$by=" order by ".$_GET["by"];
		}else
		{
			$by=" order by post_id";
		}
		if(isset($_GET["order"]) and in_array($_GET["order"],array("asc","desc")))
		{
			$sort=$_GET["order"];
		}else 
		{
			$sort="asc";
		}
		$order=$by." ".$sort;
		
		if(isset($_GET["type"]) and array_key_exists($_GET["type"],$this->contentTypes()))
		{
			if(isset($_GET["user"]))
			{
				$sql="where content_type=? and post_author=? ".$order.$limit;
				$ar=array($_GET["type"],$this->author);
			}else
			{
				$sql="where content_type=? ".$order.$limit;
				$ar=array($_GET["type"]);	
			}
		}else 
		{
			if(isset($_GET["user"]))
			{
				$sql="where post_author=? ".$order.$limit;
				$ar=array($this->author);
			}else
			{
				$sql=$order.$limit;
				$ar=NULL;
			}
		}
		$this->paginationResult="Toplam içerik = <b>".$this->totalRecords."</b>; Toplam sayfa = <b>".$totalPages."</b>";
		$query=new Model();
		$query->fetch_query("posts",$sql,$ar);
		$contentTypes=$this->contentTypes();
		foreach($query->results as $row)
		{
			$editLink=$this->editLink($row["content_type"],$row["post_id"],$row["post_author"],"Düzenle");
			$titleLink=$this->editLink($row["content_type"],$row["post_id"],$row["post_author"],$row["post_title"]);
			if($this->adminEditor() or $row["post_author"]==$this->author)
			{
				$checkbox="<input type='checkbox' name='selected[]' value='".$row["post_id"]."'>";
			}else
			{
				$checkbox=NULL;
			}
			echo "<tr>
				  	<td>".$checkbox."</td>
					<td>".$row["post_id"]."</td>
					<td>".$titleLink."</td>
					<td>".$this->getPostCategory($row["post_category"])."</td>
					<td>".$contentTypes[$row["content_type"]]."</td>
					<td>".$editLink."</td>
				  </tr>";
		}
	}
	public function editLink($type,$id,$author,$text)
	{
		switch($type)
		{
			case "post":  $link=URL."/content/edit&type=post&id=".$id; break;
			case "video": $link=URL."/content/edit&type=video&id=".$id; break;
			case "audio": $link=URL."/content/edit&type=audio&id=".$id; break;
			case "photo": $link=URL."/content/edit&type=photo&id=".$id; break;
			case "html": $link=URL."/content/edit&type=html&id=".$id; break;
			case "other": $link=URL."/content/edit&type=other&id=".$id; break;
			default :
						  $link=URL."/content/edit&type=post&id=".$id; break;
		}
		if($this->adminEditor() or $author==$this->author)
		{
			return "<a href='$link'>".$text."</a>";
		}else
		{
			return "<a href='#'>$text</a>";
		}
	}
	public function getPostCategory($id)
	{
		$query=new Model();
		$query->select_single_query("category","where id=?",array($id));
		$row=$query->results;
		if($row["title"])
		{
			return $row["title"];
		}else 
		{
			return "Bulunamadı";
		}
		
	}
	public function pagination()
	{
		$total=$this->totalRecords;
		if(isset($_GET["user"])){$user="&user";}else{$user=NULL;}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->orderKeys())){$by="&by=".$_GET["by"];}else{$by=NULL;}
		if(isset($_GET["order"])){$order="&order=".$_GET["order"];}else{$order=NULL;}
		if(isset($_GET["type"])){$type="&type=".$_GET["type"];}else {$type=NULL;}
		$link=URL."/content/listing".$user.$type.$by.$order;
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	
}
?>