<?php 

class Members extends Controller
{
	public $totalMembers=NULL;
	public $totalResult=NULL;
	public $row=NULL;
	public function __construct()
	{
		$this->setNewPerPage();
		$this->listPerPage();
		$this->getTotalMembers();
	}
	
	public function listing()
	{
		if($this->admin())
		{
			$this->deleteUsers();
			$this->load($this->view("view/common/header"));
			$this->load($this->view("view/common/left_column"));
			$this->load($this->view("view/members/home"));
			$this->load($this->view("view/common/footer"));
		}else 
		{
			header("location:".URL);
		}
	}
	public function deleteUsers()
	{
		if($this->admin())
		{
			if(isset($_POST["selected"]))
			{
				$deleted=NULL;
				foreach ($_POST["selected"] as $userId)
				{
					$query=new Model();
					$query->select_single_query("users","where id=?",array(abs($userId)));
					$row=$query->results;
					$username=$row["username"];
					if($row["admin"]==0)
					{
						$query->delete_query("users","where id=?",array(abs($userId)));
						$deleted.="<b>$username</b> silindi</br>";
					}else
					{
						$deleted.="<b style='color:red'>$username silmeye yetkiniz yoktur.</b></br>";
					}
				}
				echo $this->formResults($deleted);
			}
		}
	}
	public function admin()
	{
		global $session;
		if($session->userInfo["rank"]=="admin"){return true;}else{return false;}
	}
	public function memberRows()
	{
		global $session;
		if(isset($_GET["id"]))
		{
			if($this->admin())
			{
				$id=abs($_GET["id"]);
			}else
			{
				$id=$session->userInfo["id"];
			}
			$query=new Model();
			$total=$query->select_total_records("users","where id=?",array(abs($id)));
			if($total==0)
			{
				header("location:".URL."/members/listing");
			}else
			{
				$query->select_single_query("users","where id=?",array(abs($id)));
				$this->row=$query->results;
			}
		}
	}
	public function add()
	{
		if($this->admin())
		{
			$this->load($this->view("view/members/add"));
		}
	}
	public function edit()
	{
		$this->load($this->view("view/members/edit"));
	}
	public function getTotalMembers()
	{
		$query=new Model();
		if(isset($_GET["rank"]) and array_key_exists($_GET["rank"],$this->rankValue()))
		{
			$total=$query->select_total_records("users","where rank=?",array($_GET["rank"]));
		}else 
		{
			$total=$query->select_total_records("users",NULL,NULL);
		}
		$this->totalMembers=$total;
	}
	public function rankValue()
	{
		return array("admin" => "Yönetici","editor"=>"Editör","writer"=>"Yazar","user"=>"Standart Üye","subscriber"=>"Bülten Abonesi");
	}
	public function getUserLinks()
	{
		$ranks=$this->rankValue();
		if($this->admin())
		{
			echo "<a href='".URL."/members/listing'>Tüm üyeler</a>";
			foreach ($ranks as $name => $value)
			{
				echo "<a href='".URL."/members/listing&rank=".$name."'>".$value."</a>";
			}	
		}
	}
	public function rankOption($current)
	{
		$ranks=array("admin" => "Yönetici","editor"=>"Editör","writer"=>"Yazar","user"=>"Standart Üye","subscriber"=>"Bülten Abonesi");
		$options=NULL;
		foreach($ranks as $value => $op)
		{
			if($value==$current){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value."' $sc>".$op."</option>";
		}
		return $options;
	}
	public function statusOption($status)
	{
		$statusArray=array("Pasif","Aktif");
		$options=NULL;
		foreach($statusArray as $value => $op)
		{
			if($value==$status){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value ."' $sc>".$op."</option>";
		}
		return $options;
	}
	public function subscriberOption($status)
	{
		$statusArray=array("Kapalı","Açık");
		$options=NULL;
		foreach($statusArray as $value => $op)
		{
			if($value==$status){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$value ."' $sc>".$op."</option>";
		}
		return $options;
	}
	public function logout()
	{
		if(isset($_SESSION["user"]))
		{
			$query=new Model();
			$query->update_query("users","online=? where id=?",array(0,$_SESSION["user"]));
		}
		session_destroy();
		header("location:".URL);
	}
	public function orderColumns()
	{
		$columns=array("id","name","username","online","rank");
		return $columns;
	}
	public function table_title($sql_column,$text)
	{
		$columns=$this->orderColumns();
		if(isset($_GET["rank"]) and array_key_exists($_GET["rank"],$this->rankValue())){$rank="&rank=".$_GET["rank"];}else{$rank=NULL;}
		if(isset($_GET["order"])){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$columns)){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_column){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->totalMembers/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/members/listing".$rank."&by=$sql_column&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/members/listing".$rank."&by=$sql_column&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function online($int)
	{
		switch($int)
		{
			case 0:$result="<span class='offline'>Çevirim dışı</span>"; break;
			case 1:$result="<span class='green'>Çevirim içi</span>"; break;
			default:$result="<span class='offline'>Çevirim dışı</span>"; break;
		}
		return $result;
	}
	public function orderList()
	{
		return array("asc","desc");
	}
	public function rank($rank)
	{
		$ranks=array("admin" => "Yönetici","editor"=>"Editör","writer"=>"Yazar","user"=>"Standart Üye","subscriber"=>"Bülten Abonesi");
		if(array_key_exists($rank,$ranks))
		{
			return $ranks[$rank];
		}else {return "Bulunamadı!!!";}
	}
	public function listAllMembers()
	{
		$columns=$this->orderColumns();
		$orderList=$this->orderList();
		if(isset($_GET["order"]) and in_array($_GET["order"],$orderList)){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$columns)){$by=$_GET["by"];}else {$by="id";}
		$totalPages=ceil($this->totalMembers/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$start=$pageNum*$this->listPerPage-$this->listPerPage;
		$sortOrder="order by ".$by." ".$order;
		$limit=$sortOrder." limit ".$start." , ".$this->listPerPage;
		$query=new Model();
		if(isset($_GET["rank"]) and array_key_exists($_GET["rank"],$this->rankValue()))
		{
			$query->fetch_query("users","where rank=? ".$limit,array($_GET["rank"]));
		}else 
		{
			$query->fetch_query("users",$limit,NULL);
		}
		$all=$query->results;
		foreach($all as $row)
		{
			echo "<tr>
				  	<td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
					<td>".$row["id"]."</td>
					<td>".$row["name"]." ".$row["surname"]."</td>
					<td>".$row["username"]."</td>
					<td>".$this->rank($row["rank"])."</td>
					<td>".$this->online($row["online"])."</td>
					<td><a href='".URL."/members/edit&id=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
		$this->totalResult="Toplam üye = <b>".$this->totalMembers."</b>; Toplam sayfa =<b>".$totalPages."</b>";
	}
	public function pagination()
	{
		$total=$this->totalMembers;
		$columns=$this->orderColumns();
		$orderList=$this->orderList();
		if(isset($_GET["by"]) and in_array($_GET["by"],$columns)){$by="&by=".$_GET["by"];}else{$by=NULL;}
		if(isset($_GET["order"]) and in_array($_GET["order"],$orderList)){$order="&order=".$_GET["order"];}else{$order=NULL;}
		$link=URL."/members/listing".$by.$order;
		$total=ceil($total/$this->listPerPage);
		$getAllPages=$this->getPagination($total,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
	public function checkUser($id,$email,$username)
	{
		if(strlen($email)> 2 and strlen($username)>2)
		{
		$query=new Model();
		$total=$query->select_total_records("users","where id!=? and (username=? or email=?)",array($id,$username,$email));
		if($total==0){ return true;}else{return false;}
		}else {return false;}
	}
	public function addNewUser()
	{
		if($this->admin())
		{
			if(isset($_POST["username"]))
			{
				$username=$this->clear($_POST["username"]);
				$email=$_POST["email"];
				if($this->checkUser(0,$email,$username))
				{
					$password=md5($_POST["password"]);
					$name=$_POST["name"];
					$surname=$_POST["surname"];
					$phone=$_POST["phone"];
					$website=$_POST["website"];
					$about=$_POST["about"];
					$subscriber=$_POST["subscriber"];
					$rank=$_POST["rank"];
					$status=$_POST["status"];
					$author=$_SESSION["user"];
					$set="username=?,email=?,password=?,name=?,surname=?,phone=?,website=?,about=?,
					subscriber=?,rank=?,status=?,author=?";
					$ar=array($username,$email,$password,$name,$surname,$phone,$website,$about,$subscriber,$rank,$status,$author);
					$query=new Model();
					$result=$query->insert_query("users",$set,$ar);
					if($result)
					{
						$query->select_single_query("users","where email=?",array($email));
						$id=$query->results["id"];
						header("location:".URL."/members/edit&id=".$id);	
					}else
					{
						$messages="Ekleme yapılırken hata oluştur!!!";
						echo $this->formResults($messages);
					}
				}else
				{
					$messages="Lütfen eposta ve kullanıcı adına dikkat ediniz.";
					echo $this->formResults($messages);
				}
			}
		}
	}
	public function editNewUser()
	{
		global $session;
		if(isset($_POST["email"]))
		{
			$email=$_POST["email"];
			if(!filter_var($email,FILTER_VALIDATE_EMAIL))
			{
				echo $this->formResults("Lütfen geçerli bir eposta adresi giriniz!!!");
				return false;
			}
			$crank=$session->userInfo["rank"];
			$postPass=trim($_POST["password"]);
			$password=md5($postPass);
			$postPassRe=trim($_POST["re_password"]);
			$re_password=md5($postPassRe);
			$name=$_POST["name"];
			$surname=$_POST["surname"];
			$phone=$_POST["phone"];
			$website=$_POST["website"];
			$about=$_POST["about"];
			$subscriber=$_POST["subscriber"];
			if($this->admin())
			{
				$rank=$_POST["rank"];
				$status=$_POST["status"];
			}else 
			{
				$rank=$session->userInfo["rank"];
				$status=$session->userInfo["status"];
			}
			if($re_password==$password and strlen($postPassRe) > 2 and strlen($postPass) > 2)
			{
				$set="email=?,password=?,name=?,surname=?,phone=?,website=?,about=?,subscriber=?,rank=?,status=? where id=?";
				$ar=array($email,$password,$name,$surname,$phone,$website,$about,$subscriber,$rank,$status,abs($_GET["id"]));
			}else
			{
				$set="email=?,name=?,surname=?,phone=?,website=?,about=?,subscriber=?,rank=?,status=? where id=?";
				$ar=array($email,$name,$surname,$phone,$website,$about,$subscriber,$rank,$status,abs($_GET["id"]));
			}
			$query=new Model();
			$result=$query->update_query("users",$set,$ar);
			if($result)
			{
				header("location:".URL."/members/edit&id=".abs($_GET["id"]));	
			}else
			{
				$messages="Güncelleme yapılırken hata oluştur!!!";
				echo $this->formResults($messages);
			}
		}
	}
}

?>