<?php 

class Service extends Controller
{
	public $total=NULL;
	public $row=array();
	public $paginationResult=NULL;
	public function listing()
	{
		$this->deleteServices();
		$this->total();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/service/home"));
		$this->load($this->view("view/common/footer"));
	}
	public function deleteServices()
	{
		if(isset($_POST["selected"]))
		{
			$query=new Model();
			foreach($_POST["selected"] as $id)
			{
				$query->delete_query("service","where id=?",array($id));
			}
			header("location:".URL."/service/listing");
		}
	}
	public function total()
	{
		$query=new Model();
		$tot=$query->select_total_records("service",NULL,NULL);
		$this->total=$tot;
	}
	public function add()
	{
		$this->addNewService();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/service/add"));
		$this->load($this->view("view/common/footer"));
	}
	public function edit()
	{
		$this->editService();
		$this->serviceInfo();
		$this->load($this->view("view/common/header"));
		$this->load($this->view("view/common/left_column"));
		$this->load($this->view("view/service/edit"));
		$this->load($this->view("view/common/footer"));
	}
	public function editService()
	{
		if(isset($_POST["title"]))
		{
			$title=trim(strip_tags($_POST["title"]));
			if(strlen($title)>1)
			{
				$content=$_POST["content"];
				$link=trim($_POST["link"]);
				$link_text=trim($_POST["link_text"]);
				$image=abs($_POST["image"]);
				$sort_order=abs($_POST["sort_order"]);
				$query=new Model();
				$set="title=?, content=?, link=?, link_text=?, image=?, sort_order=? where id=?";
				$ar=array($title,$content,$link,$link_text,$image,$sort_order,abs($_GET["id"]));
				$up=$query->update_query("service",$set,$ar);
				if($up){header("location:".URL."/service/edit&id=".$_GET["id"]);}
			}else
			{
				echo $this->formResults("Lütfen en az 2 karakterli bir servis başlığı giriniz.");
			}
		}
	}
	public function serviceInfo()
	{
		if(isset($_GET["id"]))
		{
			$query=new Model();
			$tot=$query->select_total_records("service","where id=?",array(abs($_GET["id"])));
			if($tot==1)
			{
				$query->select_single_query("service","where id=?",array(abs($_GET["id"])));
				$this->row=$query->results;
			}else
			{
				header("location:".URL."/service/listing");
			}
		}else
		{
			header("location:".URL."/service/listing");
		}
	}
	public function addNewService()
	{
		if(isset($_POST["title"]))
		{
			$title=trim(strip_tags($_POST["title"]));
			if(strlen($title)>1)
			{
				$content=$_POST["content"];
				$link=trim($_POST["link"]);
				$link_text=trim($_POST["link_text"]);
				$image=abs($_POST["image"]);
				$sort_order=abs($_POST["sort_order"]);
				$query=new Model();
				$set="title=?, content=?, link=?, link_text=?, image=?, sort_order=?";
				$ar=array($title,$content,$link,$link_text,$image,$sort_order);
				$add=$query->insert_query("service",$set,$ar);
				if($add){header("location:".URL."/service/listing");}
			}else
			{
				echo $this->formResults("Lütfen en az 2 karakterli bir servis başlığı giriniz.");
			}
		}
	}
	public function image($id)
	{
		$query=new Model();
		$tot=$query->select_total_records("media","where id=?",array($id));
		if($tot==1)
		{
			$query->select_single_query("media","where id=?",array($id));
			$row=$query->results;
			$query->results=NULL;
			$imgurl=$row["url"];
			$file=ROOT."uploads/".$imgurl;
			if(strlen($imgurl)>1 and file_exists($file))
			{
				$url=URL."/uploads/".$imgurl;
			}else
			{
				$url=URL."/plugins/media/image.png";
			}
		}else
		{
			$url=URL."/plugins/media/image.png";
		}
		return $url;
	}
	public function listServices()
	{
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else{$by="id";}
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else{$order="desc";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$by="order by ".$by." ".$order;
		$start=($pageNum*$this->listPerPage)-($this->listPerPage);
		$limit=" limit ".$start.",".$this->listPerPage;
		$this->paginationResult="Toplam servis = <b>".$this->total."</b>; Toplam sayfa = <b>".$totalPages."</b> ";
		$query=new Model();
		$query->fetch_query("service",$by.$limit,NULL);
		$results=$query->results;
		foreach($results as $row)
		{
			$image="<img src='".$this->image($row["image"])."' title='".$row["title"]."'>";
			echo "<tr>
				  <td><input type='checkbox' name='selected[]' value='".$row["id"]."'></td>
				  <td>#".$row["id"]."</td>
				  <td>".$image."</td>
				  <td>".htmlspecialchars($row["title"])."</td>
				  <td>".$row["sort_order"]."</td>
				  <td><a href='".URL."/service/edit&id=".$row["id"]."'>Düzenle</a></td>
				  </tr>";
		}
	}
	public function titleBy()
	{
		return array("image","title","id","sort_order");
	}
	public function order()
	{
		return array("asc","desc");
	}
	public function table_title($sql_title,$text)
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order=$_GET["order"];}else {$order="asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by=$_GET["by"];}else {$by="id";}
		if($by==$sql_title){$class="active_column";}else {$class="passive_column";}
		if($order=="asc"){$class="class='".$class." order_asc'";}else{$class="class='".$class." order_desc'";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		if($order=="asc")
		{
			return "<a href='".URL."/service/listing&by=$sql_title&order=desc&p=".$pageNum."' $class>".$text."</a>";
		}else
		{
			return "<a href='".URL."/service/listing&by=$sql_title&order=asc&p=".$pageNum."' $class>".$text."</a>";
		}
	}
	public function pagination()
	{
		if(isset($_GET["order"]) and in_array($_GET["order"],$this->order())){$order="&order=".$_GET["order"];}else {$order="&order=asc";}
		if(isset($_GET["by"]) and in_array($_GET["by"],$this->titleBy())){$by="&by=".$_GET["by"];}else {$by="&by=id";}
		$totalPages=ceil($this->total/$this->listPerPage);
		$pageNum=$this->getPageNum($totalPages);
		$link=URL."/service/listing".$by.$order;
		$getAllPages=$this->getPagination($totalPages,$link);
		$pagilinks=NULL;
		foreach ($getAllPages as $x)
		{
			$pagilinks.=$x;
		}
		return $pagilinks;
	}
}
?>