<?php 	
class Settings extends Controller
{
	public $part=NULL;
	public function __construct()
	{
		if(isset($_GET["part"]) and in_array($_GET["part"],$this->partTypes()))
		{
			$this->part=$_GET["part"];		
		}else
		{
			$this->part="common";
		}
	}
	public function update()
	{
		$this->load($this->view("view/settings/update"));
	}
	public function partTypes()
	{
		$parts=array("common","image","member","mail","template","social","contact","robots");
		return $parts;
	}
	public function getSettingPage()
	{
		if(isset($_GET["part"]) and in_array($_GET["part"],$this->partTypes()))
		{
			$view="view/settings/".$_GET["part"];		
		}else
		{
			$view="view/settings/common";
		}
		$this->load( $this->view($view) );
		
	}
	public function updatePerSet($name,$value)
	{
		$query=new Model();
		$tot=$query->select_total_records("settings","where set_name=?",array($name));
		if($tot==0)
		{
			$query->insert_query("settings","set_name=?, set_value=?",array($name,$value));
		}else
		{
			$query->update_query("settings","set_value=? where set_name=?",array($value,$name));
		}
		$query=NULL;
	}
	public function updateSettings()
	{
		if(isset($_POST["updateSettings"]))
		{
			$result=NULL;
			foreach($_POST as $name => $value)
			{
				if($name!="updateSettings")
				{
					$this->updatePerSet($name,$value);
				}
			}
			header("location:".URL."/settings/update&part=".$this->part);
		}
	}
	public function getImage($setName)
	{
		$image=$this->data[$setName];
		if(strlen($image)<1)
		{
			$img=URL."/plugins/media/noimage.png";
		}else 
		{
			$img=$image;
		}
		return $img;
	}
	public function yesNo($opt)
	{
		$ar=array("Hayır","Evet");
		foreach($ar as $in =>$key)
		{
			if($in==$opt){$sc="selected='selected'";}else{$sc=NULL;}
			echo "<option value='".$in."' $sc>".$key."</option>";
		}
	}
	public function getdata($name)
	{
		if(isset($this->data[$name])){return $this->data[$name];}else{return NULL;}
		
	}
	public function updateTxt()
	{
		if(isset($_POST["robots_txt"]))
		{
			$txt=$_POST["robots_txt"];
			$robots_txt="../robots.txt";
			if(file_exists($robots_txt))
			{
				$fopen=fopen($robots_txt,"w");
				fwrite($fopen,$txt);
				fclose($fopen);
			}else
			{
				touch($robots_txt);
				$fopen=fopen($robots_txt,"w");
				fwrite($fopen,$txt);
				fclose($fopen);
			}
		}
	}
	public function robotsTxt()
	{
		$robots_txt="../robots.txt";
		if(file_exists($robots_txt))
		{
			$filec=file_get_contents($robots_txt);
		}else
		{
			$filec=NULL;
		}
		return $filec;
	}
	public function menuOption($value)
	{
		$query=new Model();
		$query->fetch_query("menu",NULL,NULL);
		$results=$query->results;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$value){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
			
		}
		return $options;
	}
	public function get_categories($catid)
	{
		$query=new Model();
		$query->fetch_query("category","where parent_id=? order by sort_order asc, title asc",array(0));
		$results=$query->results;
		$query=NULL;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$catid){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
	public function get_banners($id)
	{
		$query=new Model();
		$query->fetch_query("banner_group","order by title asc",NULL);
		$results=$query->results;
		$query=NULL;
		$options=NULL;
		foreach($results as $row)
		{
			if($row["id"]==$id){$sc="selected='selected'";}else{$sc=NULL;}
			$options.="<option value='".$row["id"]."' ".$sc.">".$row["title"]."</option>";
		}
		return $options;
	}
}
?>