<?php 
require_once SITE."system/inc/functions.php";
class Controller
{
	public $plugins=array("home","post","page","category","search","user");
	public $seflink=NULL;
	public $temp_url=NULL;
	public $template=NULL;
	public $settings=array();
	public $widget=NULL;
	public function __construct()
	{
		$this->settings();
	}
	public function plugin($plugin,$seflink)
	{
		if(in_array($plugin,$this->plugins))
		{
			$this->seflink=$seflink;
			$this->load($plugin);
		}
	}
	public function load($plugin)
	{
		require_once(SITE."system/class/".$plugin.".php");
		$class=new $plugin();
		$class->init();
	}
	public function view($template_part)
	{
		require(SITE."temp/".$this->template."/".$template_part.".php");
	}
	public function settings()
	{
		$query=new Model();
		$query->fetch_query("settings",NULL,NULL);
		$results=$query->results;
		$query=NULL;
		foreach($results as $row)
		{
			$set_name=$row["set_name"];
			$set_value=$row["set_value"];
			$this->settings[$set_name]=$set_value;
		}
		$this->temp_url=URL."/temp/".$this->settings["template"];
		$this->template=$this->settings["template"];
	}
	public function get($part)
	{
		global $widget;
		$this->widget=$widget;
		return $this->view($part);
	}
	public function inc($class)
	{
		require(SITE."system/inc/".$class.".php");
	}
	public function getPageNum($total)
	{
		if(isset($_GET["p"])) $p=$_GET["p"];
		else $p=1;
		if($p>=$total) $p=$total;
		elseif($p<=0) $p=1;
		return $p;
	}
	public function getPagination($total,$link)
	{
		$stepby=6;
		$halfStep=3;
		$pages=array();
		$allPages=array();
		$p=$this->getPageNum($total);
		if($p>=$stepby and $stepby<=$total){
			if($p+$halfStep<=$total){	
				$x=$p-2;
				while($x<$p+3){
					array_push($pages,$x);
					$x++;
				}
			}else {	
				$x=$total-$stepby+2;
				while($x<=$total){
					array_push($pages,$x);
					$x++;
				}
			}
			
		}elseif($p<$stepby and $stepby<=$total){
			$x=0;
			while($x<$stepby){
				$x++;
				array_push($pages,$x);
			}
		}elseif($p<$stepby and $stepby>$total){
			$x=0;
			while($x<$total){
				$x++;
				array_push($pages,$x);
			}
		}
		if($p<=1){ $pre=1; }else{$pre=$p-1;}
		if($p>=$total){$next=$total;}else{$next=$p+1;}
		$lastPage=$total;
		array_push($allPages,"<a href='".$link."&p=1' class='firstPage'>&laquo;</a>");
		array_push($allPages,"<a href='".$link."&p=".$pre."' class='previousPage'>&#8249;</a>");
		foreach($pages as $a){
			if($a==$p){
				$cl="class='focused_page'";
			}else {
				$cl=NULL;
			}
			array_push($allPages,"<a href='".$link."&p=".$a."' ".$cl.">".$a."</a>");
		}
		array_push($allPages,"<a href='".$link."&p=".$next."' class='nextPage'>&#8250;</a>");
		array_push($allPages,"<a href='".$link."&p=".$lastPage."' class='lastPage'>&raquo;</a>");
		return $allPages;
	}
	public function clear($text) 
	{
		$text = (trim($text));
		$search = array("#","/",'"',"'",'Ç','ç','Ğ','ğ','ı','İ','Ö','ö','Ş','ş','Ü','ü',' ', 'A','B','C',"D","E","F","G","H","I","J","K","L","M","N","O","P","R","S","T","V","U","Z","Y","W","X","Q");
		$replace = array("-","I","","",'c','c','g','g','i','i','o','o','s','s','u','u','-','a','b','c',"d","e","f","g","h","i","j","k","l","m","n","o","p","r","s","t","v","u","z","y","w","x","q");
		$new_text = str_replace($search,$replace,$text);
		return $new_text;
	}
}

?>